CREATE OR REPLACE VIEW optimized_latest_listen AS
SELECT
  l.track_name::TEXT AS track_name,
  l.artist_name::TEXT AS artist_name,
  a.emoji::TEXT AS artist_emoji,
  g.emoji::TEXT AS genre_emoji,
  a.slug::TEXT AS url,
  NULL::FLOAT AS total_duration,
  NULL::FLOAT AS progress_ticks
FROM
  listens l
JOIN
  artists a
  ON l.artist_name = a.name_string
LEFT JOIN
  genres g
  ON a.genres = g.id
ORDER BY l.listened_at DESC
LIMIT 1;
